/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
define([
    'jquery',
    'domReady',
    'jquery/ui'
], function ($, domReady) {
    'use strict';

    $.widget('filoblu.generalTrigger', {
        options: {
            target: '',
            elementToClose:'',
            action: 'default',
            activeClass: 'active',
            animation: 'fade'
        },

        _create: function(){
            var self = this,
                trigger = this.element,
                target = $(this.options.target),
                elementToClose = $(this.options.elementToClose),
                action = this.options.action,
                activeClass = this.options.activeClass,
                animation = this.options.animation;

            trigger.on('click', function (e) {
                if (target.length > 0) {
                    self.triggerAction(target,action,animation,elementToClose,activeClass);
                } else {
                    console.log('Target not found in the DOM');
                }
            });
        },

        triggerAction: function (target,action,animation,elementToClose,activeClass) {
            var targetSelector = $(target);

            switch (action) {
                case 'toggle':
                    if (elementToClose.hasClass(activeClass)) {
                        elementToClose.toggle(animation,{direction:'up'},300);
                        elementToClose.toggleClass(activeClass);
                        targetSelector.toggle(animation,{direction:'up'},300);
                        targetSelector.toggleClass(activeClass);
                    } else {
                        targetSelector.toggle(animation,{direction:'up'},300);
                        targetSelector.toggleClass(activeClass);
                    }
                    break;

                default:
                    console.log('Action ' + action + ' not supported')

            }
        }

    });

    return $.filoblu.generalTrigger;
});
